diff --git a/northd/ovn-northd.c b/northd/ovn-northd.c
index 3de71612b..c681d5cbf 100644
--- a/northd/ovn-northd.c
+++ b/northd/ovn-northd.c
@@ -1928,6 +1928,8 @@ update_dynamic_addresses(struct dynamic_address_update *update)
 
     struct ds new_addr = DS_EMPTY_INITIALIZER;
     ds_put_format(&new_addr, ETH_ADDR_FMT, ETH_ADDR_ARGS(mac));
+
+
     ipam_insert_mac(&mac, true);
 
     if (ip4) {
@@ -6950,24 +6952,24 @@ build_lswitch_flows(struct hmap *datapaths, struct hmap *ports,
         struct ds action = DS_EMPTY_INITIALIZER;
 
         ds_clear(&match);
-        ds_put_cstr(&match, "udp.dst == 53");
+        const char *dns_match = "udp.dst == 53";
         ds_put_format(&action,
                       REGBIT_DNS_LOOKUP_RESULT" = dns_lookup(); next;");
         ovn_lflow_add(lflows, od, S_SWITCH_IN_DNS_LOOKUP, 100,
-                      ds_cstr(&match), ds_cstr(&action));
+                      dns_match, ds_cstr(&action));
         ds_clear(&action);
-        ds_put_cstr(&match, " && "REGBIT_DNS_LOOKUP_RESULT);
-        ds_put_format(&action, "eth.dst <-> eth.src; ip4.src <-> ip4.dst; "
+
+        const char *dns_match2 = "udp.dst == 53 && "REGBIT_DNS_LOOKUP_RESULT;
+        const char *dns_action = "eth.dst <-> eth.src; ip4.src <-> ip4.dst; "
                       "udp.dst = udp.src; udp.src = 53; outport = inport; "
-                      "flags.loopback = 1; output;");
+                      "flags.loopback = 1; output;";
         ovn_lflow_add(lflows, od, S_SWITCH_IN_DNS_RESPONSE, 100,
-                      ds_cstr(&match), ds_cstr(&action));
-        ds_clear(&action);
-        ds_put_format(&action, "eth.dst <-> eth.src; ip6.src <-> ip6.dst; "
+                      dns_match2, dns_action);
+        dns_action = "eth.dst <-> eth.src; ip6.src <-> ip6.dst; "
                       "udp.dst = udp.src; udp.src = 53; outport = inport; "
-                      "flags.loopback = 1; output;");
+                      "flags.loopback = 1; output;";
         ovn_lflow_add(lflows, od, S_SWITCH_IN_DNS_RESPONSE, 100,
-                      ds_cstr(&match), ds_cstr(&action));
+                      dns_match2, dns_action);
         ds_destroy(&action);
     }
 
@@ -7839,10 +7841,10 @@ add_ecmp_symmetric_reply_flows(struct hmap *lflows,
                             &st_route->header_);
 
     ds_clear(&actions);
-    ds_put_cstr(&actions, "eth.dst = ct_label.ecmp_reply_eth; next;");
+    const char *action = "eth.dst = ct_label.ecmp_reply_eth; next;";
     ovn_lflow_add_with_hint(lflows, od, S_ROUTER_IN_ARP_RESOLVE,
                             200, ds_cstr(&ecmp_reply),
-                            ds_cstr(&actions), &st_route->header_);
+                            action, &st_route->header_);
 }
 
 static void
@@ -8734,9 +8736,9 @@ build_lrouter_flows(struct hmap *datapaths, struct hmap *ports,
 
         /* TTL discard */
         ds_clear(&match);
-        ds_put_cstr(&match, "ip4 && ip.ttl == {0, 1}");
+        const char *ttl_match = "ip4 && ip.ttl == {0, 1}";
         ovn_lflow_add(lflows, od, S_ROUTER_IN_IP_INPUT, 30,
-                      ds_cstr(&match), "drop;");
+                      ttl_match, "drop;");
 
         /* Pass other traffic not already handled to the next table for
          * routing. */
@@ -8778,14 +8780,13 @@ build_lrouter_flows(struct hmap *datapaths, struct hmap *ports,
             ds_put_cstr(&match, " && icmp4.type == 8 && icmp4.code == 0");
 
             ds_clear(&actions);
-            ds_put_format(&actions,
-                "ip4.dst <-> ip4.src; "
-                "ip.ttl = 255; "
-                "icmp4.type = 0; "
-                "flags.loopback = 1; "
-                "next; ");
+            const char * icmp_actions = "ip4.dst <-> ip4.src; "
+                                    "ip.ttl = 255; "
+                                    "icmp4.type = 0; "
+                                    "flags.loopback = 1; "
+                                    "next; ";
             ovn_lflow_add_with_hint(lflows, op->od, S_ROUTER_IN_IP_INPUT, 90,
-                                    ds_cstr(&match), ds_cstr(&actions),
+                                    ds_cstr(&match), icmp_actions,
                                     &op->nbrp->header_);
         }
 
@@ -9184,14 +9185,14 @@ build_lrouter_flows(struct hmap *datapaths, struct hmap *ports,
             ds_put_cstr(&match, " && icmp6.type == 128 && icmp6.code == 0");
 
             ds_clear(&actions);
-            ds_put_cstr(&actions,
+            const char *lrp_actions =
                         "ip6.dst <-> ip6.src; "
                         "ip.ttl = 255; "
                         "icmp6.type = 129; "
                         "flags.loopback = 1; "
-                        "next; ");
+                        "next; ";
             ovn_lflow_add_with_hint(lflows, op->od, S_ROUTER_IN_IP_INPUT, 90,
-                                    ds_cstr(&match), ds_cstr(&actions),
+                                    ds_cstr(&match), lrp_actions,
                                     &op->nbrp->header_);
         }
 
@@ -10449,13 +10450,12 @@ build_lrouter_flows(struct hmap *datapaths, struct hmap *ports,
                                       REG_NEXT_HOP_IPV4 " == %s",
                                       peer->json_key, vip);
 
-                        ds_clear(&actions);
-                        ds_put_format(&actions,
-                                      "eth.dst = 00:00:00:00:00:00; next;");
+                        const char *arp_actions =
+                                      "eth.dst = 00:00:00:00:00:00; next;";
                         ovn_lflow_add_with_hint(lflows, peer->od,
                                                 S_ROUTER_IN_ARP_RESOLVE, 100,
                                                 ds_cstr(&match),
-                                                ds_cstr(&actions),
+                                                arp_actions,
                                                 &op->nbsp->header_);
                         break;
                     }